// The contents of this file will be executed before any of
// your view controllers are ever executed, including the index.
// You have access to all functionality on the `Alloy` namespace.
//
// This is a great place to do any initialization for your app
// or create any global variables/functions that you'd like to
// make available throughout your app. You can easily make things
// accessible globally by attaching them to the `Alloy.Globals`
// object. For example:
//
// Alloy.Globals.someGlobalFunction = function(){};

Alloy.Globals.base_path = 'http://192.168.1.17:3000/itravel/';
Alloy.Globals.api_path = Alloy.Globals.base_path + 'mobile/';
Alloy.Globals.currentTab = 'nearbyTab';
Alloy.Globals.searchFilters = {
	distance: null,
	sort: null,
	options: []
};

//Alloy.Models.placesListItem = new Backbone.Model();
Alloy.Collections.placesList = new Backbone.Collection();

var url = Alloy.Globals.api_path + "getCategories";
var xhr = Ti.Network.createHTTPClient({
    onload: function(e) {
		var resp = JSON.parse(this.responseText),
			cats = resp.categories,
			len = cats.length,
			remoteCatIds = [],
			i, cat, model;

		var v = Ti.App.Properties.getInt('categories_version', 0);

		if ( resp.version > v ) {
			for (i = 0; i < len; i++) {
				cat = cats[i];

				remoteCatIds.push(cat.id);

				var model = Alloy.createModel('category', {
					id: cat.id,
					name_ka: cat.name.ka,
					name_en: cat.name.en,
					name_ru: cat.name.ru,
					parent: cat.parent,
					parent_parent: cat.parent_parent
				});
				model.save();
			}

			//remove deleted categories
			var cats = Alloy.createCollection('category');
			cats.fetch({
				success: function() {
					_.each(cats.models, function(model, index) {
						if ( remoteCatIds.indexOf(model.get('id')) < 0 ) {
							model.destroy();
						}
					});
				}
			});

			Ti.App.Properties.setInt('categories_version', resp.version);
		}
    },
    onerror: function(e) {
		//should log somewhere!
		Ti.API.info('error');
    },
    timeout: 5000
});
xhr.open("GET", url);
xhr.send();


function generateSearchString(obj) {
	if ( typeof obj !== 'object' ) return false;

	var strParts = [],
		key;

	for ( key in obj ) {
		if ( obj.hasOwnProperty(key) ) {
			strParts.push(encodeURIComponent(key) + '=' + encodeURIComponent(obj[key]));
		}
	}

	return strParts.length > 0 ? strParts.join('&') : '';
}

function searchWrapper(params_str, page, callback) {
	var params = "?" + params_str + '&page=' + page;
	// Ti.API.info(params);
	_get('search', params, callback, 'json');
}

function _get(endpoint, params_str, callback, type) {
	var base_url = Alloy.Globals.api_path,
		url =  base_url + endpoint + '/' + params_str;

	Ti.API.info(url);

	var xhr = Ti.Network.createHTTPClient({
	    onload: function(e) {
			if ( typeof callback === 'function' ) {
				callback( (type === 'json') ? JSON.parse(this.responseText) : this.responseText );
			}
	    },
	    onerror: function(e) {
	        Ti.API.debug(e.error);
	    },
	    timeout: 5000
	});
	xhr.open("GET", url);
	xhr.send();
}
