var args = arguments[0] || {};
var catid = args.catid || null;
var placeClickAction = args.placeClickAction || null;
var hidePullView = args.hidePullView || false;
var placesPerPage = 8;

var placesListCollection = Alloy.Collections.placesList;

var wHeight;

if ( hidePullView !== true ) {
	var pullview = Alloy.createController('partials/pullview');
	$.placesListView.pullView = pullview.getView();
}

exports.showLoading = function() {
	Ti.API.info('** >> ** showLoading called');
	//$.placesListView.setVisible(false);
	var imgs = [],
		i;
	for ( i = 1; i<=12; i++ ) {
		imgs.push('images/loader/' + i + '.png');
	}
	$.loadingImg.setImages(imgs);
	$.loadingImg.start();
	$.loading.setVisible(true);
};

exports.showLoading();

function placeItemClicked(e) {
	var placeItem = e.section.getItemAt(e.itemIndex);

	if ( typeof placeClickAction === 'function' ) {
		placeClickAction(placeItem);
	}
	else {
		Alloy.Globals.navigation.open('place', {place: placeItem});
	}
}

function pullEvent(e) {
	pullview.onPullEvent(e);
}

function onPulledEvent() {
	$.placesListView.setContentInsets({top:50}, {animated:true});

	setTimeout(function() {
		$.placesListView.setContentInsets({top:0}, {animated:true});
		pullview.onPulledEvent();
	}, 2000);
}

//detect window height
// $.listwin.addEventListener('postlayout', function() {
	// wHeight = $.listwin.rect.height;
//
	// $.placesListView.height = wHeight - 40 - 45;
// });

exports.populateList = function(data, method) {
	var placesData = data.places,
		places = [],
		i,
		place;

	for ( i in placesData) {
		place = placesData[i];
		places.push({
			name: place.name,
			address: place.address.street_name + ' ' + place.address.street_number,
			thumb: "/images/80x80.jpg",
			distance: "2.4 კმ"
		});
	}

	if ( method === 'append' ) {
		placesListCollection.add(places);
	}
	else {
		placesListCollection.reset(places);
	}

	if ( data.current_batch >= placesPerPage ) {
		$.placesListView.setMarker({sectionIndex:0, itemIndex: ($.placesListView.sections[0].items.length - 1)});
	}

	Ti.API.info('** >> ** populateList called');
	$.loading.setVisible(false);
	// $.placesListView.setVisible(true);
};

function markerEvent() {
	Ti.API.info('marker event');

	$.trigger('marker');
}
