var args = arguments[0] || {};

$.searchField.focus();
$.near.setColor('blue');

var isNearMeSelected = 1,
	nearInitValue = $.near.getValue(),
	selectedLocationId = null,
	chnagedFromKeyboard = true, //setValue fires change event
	tout;

function closeMe() {
	Alloy.Globals.navigation.closeModal();
}

function doSearch() {
	closeMe();

	var searchParams = {
		s: $.searchField.getValue()
	};

	Alloy.Globals.navigation.open('search', {
		searchParams: searchParams
	});
}

function nearMeChanged(e) {
	_populateListData([]);

	if ( chnagedFromKeyboard && e.value.length >= 2 && isNearMeSelected != 1 ) {
		if ( tout ) {
			clearTimeout(tout);
		}

		tout = setTimeout(function() {
			var params_str = '?value=' + e.source.getValue();
			_get('street_autocomplete', params_str, function(resp) {
				_populateListData(resp);
			}, 'json');
		}, 300);
	}

	if ( ! chnagedFromKeyboard )
		chnagedFromKeyboard = true;

	if ( isNearMeSelected === 1 ) {
		if ( e.value.length > 1 ) {
			if ( e.value.length > nearInitValue.length ) {
				chnagedFromKeyboard = false;
				e.source.setValue(e.value.slice(-1));
			}
			else {
				chnagedFromKeyboard = false;
				e.source.setValue('');
			}
		}
		$.near.setColor('black');
		isNearMeSelected = 0;
	}
	$.locationsList.setVisible(true);
}

function nearMeFocus() {
	$.locationsList.setVisible(true);
	$.locationIcon.setOpacity(0.5);
}

function nearMeBlur() {
	$.locationsList.setVisible(false);
	$.locationIcon.setOpacity(0.3);

	if ( isNearMeSelected === 0 ) {
		$.near.setColor('black');
	}
	else {
		$.near.setColor('blue');
	}
}

function locationClicked(e) {
	var item = $.locationsList.sections[e.sectionIndex].getItemAt(e.itemIndex);
	$.near.setValue(item.name.text);
	$.locationsList.setVisible(false);

	if ( e.itemIndex > 0 ) {
		$.near.setColor('black');
		selectedLocationId = item.locationId;
		isNearMeSelected = 0;
	}
	else {
		$.near.setColor('blue');
		isNearMeSelected = 1;
	}
}

function _populateListData(locations) {
	var items = [],
		i, len;
	items.push({
		template: 'locationItemNearMe',
		name: {
			text: 'ჩემთან ახლოს'
		}
	});

	for ( i = 0, len = locations.length; i < len; i++ ) {
		items.push({
			locationId: locations[i].value,
			name: {
				text: locations[i].name
			}
		});
	}

	$.locationsList.sections[0].items = items;
}
